#
# cat.py - DITrack 'cat' command
#
# Copyright (c) 2006 The DITrack Project, www.ditrack.org.
#
# $Id: cat.py 476 2006-08-23 00:53:11Z vss $
# $HeadURL: file:///X/svn/ditrack/src/tags/0.4/DITrack/Command/cat.py $
#
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions are met:
#
#  * Redistributions of source code must retain the above copyright notice, 
# this list of conditions and the following disclaimer.
#  * Redistributions in binary form must reproduce the above copyright notice, 
# this list of conditions and the following disclaimer in the documentation 
# and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
# POSSIBILITY OF SUCH DAMAGE.
#

import sys

# DITrack modules
import DITrack.Command.generic

class Handler(DITrack.Command.generic.Handler):
	canonical_name = "cat"
	description = """Dump full text of the issue.
usage: %s ISSUENUM""" % canonical_name

	def run(self, opts, globals):
		self.check_options(opts)

		if len(opts.fixed) != 2:
			self.print_help(globals)
			sys.exit(1)

		db = DITrack.Util.common.open_db(opts)

		issue_id = int(opts.fixed[1])
		issue = DITrack.DB.Issue.fromfile(globals, db, issue_id)

		print "Issue: %d" % issue_id

		print issue.info.as_string()

		print globals.text_delimiter

		for cid in range(issue.comments_qty):
			print "Comment: %d" % (cid + 1)
			print issue.comment[cid].as_string()
			print globals.text_delimiter
